package IConfig;

$VIRSION = '1.0';

#===============================================================================
# CONSTRUCTOR
#		$obj = new IConfig($config_init_file);
#===============================================================================
sub new
{
    my($pkg) = shift;
    my($cfginit) = shift;
    my($self) = {};
    bless $self, $pkg;
    # config init file
    $self->{'cfginit'} = $cfginit;
    # will not parse content by default
    $self->{'cfgparse'} = 0;
		$self->{'config'} = {};
    return $self;
}

#===============================================================================
#	load indicated config file
#		$obj->LoadConfig();
#===============================================================================
sub LoadConfig
{
		my($self) = shift;
    my ($section,$subsection,$key,$value)=();
		my $cfg = {};
    my ($i,$j)=(100,100);
		local *FILE;
		# return error if file not specified
		return $self->setError(q{To init module use : $obj = new IConfig('./templates_directory/config_file.init') or $obj = new IConfig();	$obj->{'cfginit'} = './templates_directory/config_file.init';}) if ! defined $self->{'cfginit'};
		# return error if file do not exist
		return $self->setError("$! : $self->{'cfginit'}") if !-e $self->{'cfginit'};
		# open and read file. return error if we can not
		open (FILE, "$self->{'cfginit'}") || return $self->setError("$! : $self->{'cfginit'}");
		while (my $line = <FILE>)
		{
			# empty lines and comments
      next if $line =~ /^\s*$/;
      next if $line =~ /^\s*\#/;
			# sections {}
      if ($line =~ /^\s*\{.*\}\s*$/)
			{
				++$i;
	      $section=$line;
	      $section=~s/^\s*\{//;
	      $section=~s/\}\s*$//;
	      $section=~s/^\s+//;
	      $section=~s/\s+$//;
				$cfg{"<!--$i-->$section"}={};
				next;
      }
			# subsections []
      if ($line =~ /^\s*\[.*\]\s*$/)
			{
				++$j;
	      $subsection=$line;
	      $subsection=~s/^\s*\[//;
	      $subsection=~s/\]\s*$//;
	      $subsection=~s/^\s+//;
	      $subsection=~s/\s+$//;
				$cfg{"<!--$i-->$section"}{"<!--$j-->$subsection"}={};
	      next;
      }
			# keys and values
      ($key,$value) = split /\=/,$line,2;
      $key=~s/^\s+//;$key=~s/\s+$//;
      $value=~s/^\s+//;$value=~s/\s+$//;
			$cfg{"<!--$i-->$section"}{"<!--$j-->$subsection"}{$key} = $value;
		}
		close(FILE);
		foreach $section(keys %cfg)	{ foreach $subsection(keys %{$cfg{$section}})
		{
			my $type = $cfg{$section}{$subsection}{'type'};
			my $name = $cfg{$section}{$subsection}{'name'};
			my $value = $cfg{$section}{$subsection}{'value'};
			my $attr = $cfg{$section}{$subsection}{'attr'};
			my $text = $cfg{$section}{$subsection}{'text'};
			delete $cfg{$section}{$subsection}{'type'};
			delete $cfg{$section}{$subsection}{'name'};
			delete $cfg{$section}{$subsection}{'value'};
			delete $cfg{$section}{$subsection}{'attr'};
			delete $cfg{$section}{$subsection}{'text'};
			if (lc($type) =~ 'text"*$' or lc($type) =~ 'password')
			{
				eval('$value = $main::'.$name) if $self->{'cfgparse'} and eval('defined $main::'.$name);
				$cfg{$section}{$subsection}{'formelement'} = qq{<input type="$type" name="$name" value="$value" $attr>}
			}
			elsif (lc($type) =~ 'textarea')
			{
				eval('$value = $main::'.$name) if $self->{'cfgparse'} and eval('defined $main::'.$name);
				$value =~ s'&'&#38;'g; $value =~ s'<'&#60;'g; $value =~ s'>'&#62;'g; $value =~ s!\\n!\n!g;
				$cfg{$section}{$subsection}{'formelement'} = qq{<textarea name=$name $attr>$value</textarea>};
			}
			elsif (lc($type) =~ 'radio')
			{
				my @text=split(/\;/, $text); my $i=-1;
				foreach my $v(split(/\;/, $value))
				{
		      $v=~s/^\s+//;$v=~s/\s+$//;++$i;
		      $text[$i]=~s/^\s+//;$text[$i]=~s/\s+$//;
					if ($self->{'cfgparse'} and eval('defined $main::'.$name)) { $v=~s/^<(.*)>$/$1/; $v="\"$v\" checked" if $v eq eval('$main::'.$name)}
					elsif ($v=~s/^<(.*)>$/$1/) { $v="\"$v\" checked" }
					else { $v="\"$v\"" }
					$cfg{$section}{$subsection}{'formelement'} .= qq{<input type="$type" name="$name" value=$v $attr>&nbsp;$text[$i]}
				}
			}
			elsif (lc($type) =~ 'checkbox')
			{
				my @text=split(/\;/, $text); my @name=split(/\;/, $name); my $i=-1;
				foreach my $v(split(/\;/, $value))
				{
		      $v=~s/^\s+//;$v=~s/\s+$//;++$i;
		      $text[$i]=~s/^\s+//;$text[$i]=~s/\s+$//;
		      $name[$i]=~s/^\s+//;$name[$i]=~s/\s+$//;
					my $checked = '';
					if ($self->{'cfgparse'} and eval('defined $main::'.$name[$i])) { $v=~s/^<(.*)>$/$1/; $checked='checked' if grep ($v eq $_, split(/\,/, eval('$main::'.$name[$i]))) }
					elsif ($v=~s/^<(.*)>$/$1/) { $checked='checked' }
					$v="\"$v\" $checked";
					$cfg{$section}{$subsection}{'formelement'} .= qq{<input type="$type" name="$name[$i]" value=$v $attr>&nbsp;$text[$i]}
				}
			}
			elsif (lc($type) =~ 'select')
			{
				my @text=split(/\;/, $text); my $i=-1;
				$cfg{$section}{$subsection}{'formelement'} .= qq{<select name=$name $attr>};
				foreach my $v(split(/\;/, $value))
				{
		      $v=~s/^\s+//;$v=~s/\s+$//;++$i;
		      $text[$i]=~s/^\s+//;$text[$i]=~s/\s+$//;
					my $selected = '';
					if ($self->{'cfgparse'} and eval('defined $main::'.$name)) { $v=~s/^<(.*)>$/$1/; $selected='selected' if $v eq eval('$main::'.$name)}
					elsif ($v=~s/^<(.*)>$/$1/) { $selected='selected' }
					$v="\"$v\" $selected";
					$cfg{$section}{$subsection}{'formelement'} .= qq{<option value=$v>$text[$i]}
				}
				$cfg{$section}{$subsection}{'formelement'} .= qq{</select>};
			}
		} };
		$self->{'config'} = \%cfg;
    return 0;
}

#===============================================================================
# set errorstring in $self->{'error'} and return -1
#		$obj->setError($errormessage);
#===============================================================================
sub setError
{
    my($self)     = shift;
    my($errorMsg) = shift;
    $self->{'error'} = $errorMsg if $errorMsg !~ /^\s*$/;
    return -1;
}

1;

